/* proto.h made 
Fri Jul  5 17:20:31 CDT 1991, modified Jul 8 by hand to remove ROO stuff WWM.
*/

/* main.c */

void print_banner();
void interrupt_interact();

/* av.c */

char *tp_alloc();
struct term *get_term();
void free_term();
struct rel *get_rel();
void free_rel();
struct sym_ent *get_sym_ent();
void free_sym_ent();
struct term_ptr *get_term_ptr();
void free_term_ptr();
struct formula_ptr_2 *get_formula_ptr_2();
void free_formula_ptr_2();
struct fpa_tree *get_fpa_tree();
void free_fpa_tree();
struct fpa_head *get_fpa_head();
void free_fpa_head();
struct context *get_context();
void free_context();
struct trail *get_trail();
void free_trail();
struct imd_tree *get_imd_tree();
void free_imd_tree();
struct imd_pos *get_imd_pos();
void free_imd_pos();
struct is_tree *get_is_tree();
void free_is_tree();
struct is_pos *get_is_pos();
void free_is_pos();
struct fsub_pos *get_fsub_pos();
void free_fsub_pos();
struct literal *get_literal();
void free_literal();
struct clause *get_clause();
void free_clause();
struct list *get_list();
void free_list();
struct clash_nd *get_clash_nd();
void free_clash_nd();
struct clause_ptr *get_clause_ptr();
void free_clause_ptr();
struct int_ptr *get_int_ptr();
void free_int_ptr();
struct ans_lit_node *get_ans_lit_node();
void free_ans_lit_node();
struct formula_box *get_formula_box();
void free_formula_box();
struct formula *get_formula();
void free_formula();
struct formula_ptr *get_formula_ptr();
void free_formula_ptr();
struct link_node *get_link_node();
void free_link_node();
void free_imd_pos_list();
void free_is_pos_list();
void print_mem();
void print_mem_brief();
int total_mem();
void print_linked_ur_mem_stats();
int term_ptr_get_size();
int is_tree_get_size();
void re_initialize_avail();
void init_mem_stats();
void add_your_mem_stats();
void print_mem_from_struct();

/* io.c */

void print_variable();
void str_print_variable();
void print_term();
void str_print_term();
int sprint_term();
void p_term();
void print_term_nl();
int proper_list();
int str_to_sn();
void mark_evaluable_symbols();
void print_syms();
void p_syms();
void free_sym_tab();
char *sn_to_str();
int sn_to_arity();
int sn_to_ec();
struct sym_ent *sn_to_node();
int in_sym_tab();
void mark_as_skolem();
int is_skolem();
void str_copy();
int str_ident();
int initial_str();
int read_buf();
void skip_white();
int is_delim();
void get_word();
struct term *str_term();
struct term *str_atom();
int set_vars();
int set_vars_term();
int var_name();
struct term *read_term();
struct term_ptr *read_list();
void print_list();
void print_error();
int is_symbol();
void bird_print();
int str_int();
int str_long();
void int_str();
void long_str();
void reverse();
void cat_str();

/* share.c */

struct term *integrate_term();
void disintegrate_term();
void zap_term();
void print_term_tab();
void p_term_tab();
void test_terms();
struct term_ptr *all_instances();
struct term_ptr *all_instances_fpa();
void bd_kludge_insert();
void bd_kludge_delete();

/* fpa.c */

void term_fpa_rec();
void fpa_insert();
void fpa_delete();
struct fpa_tree *build_tree();
struct term *next_term();
struct fpa_tree *build_for_all();
void zap_prop_tree();
void print_fpa_tab();
void p_fpa_tab();
void print_prop_tree();
void p_prop_tree();
void print_path();
void p_path();
int new_sym_num();
int new_sym_num();

/* clocks.c */

void clock_init();
long clock_val();
void clock_reset();
char *get_time();
long system_time();
long run_time();

/* unify.c */

int occur_check();
int unify();
int unify_no_occur_check();
int match();
struct term *apply();
int term_ident();
void clear_subst_2();
void clear_subst_1();
void print_subst();
void p_subst();
void print_trail();

/* demod.c */

struct term *convenient_demod();
void zap_term_special();
struct term *apply_demod();
void demod_cl();
void back_demod();
int lit_t_f_reduce();
int check_input_demod();
void new_demod();

/* weight.c */

int weight();
int wt_match();
void set_wt_list();
void weight_index_delete();
int lex_check();
int var_subset();
int order_equalities();
int term_ident_x_vars();
int new_function();

/* imd.c */

void imd_insert();
void imd_delete();
struct term *contract_imd();
void print_imd_tree();
void p_imd_tree();

/* is.c */

void is_insert();
void is_delete();
struct term_ptr *is_retrieve();
struct term *fs_retrieve();
void canc_fs_pos();
void print_is_tree();
void p_is_tree();

/* clause.c */

int next_cl_num();
void cl_integrate();
void cl_del_int();
void cl_del_non();
void cl_int_chk();
struct list *read_cl_list();
struct clause *read_clause();
int set_vars_cl();
void print_clause();
void p_clause();
void print_cl_list();
void cl_merge();
int tautology();
int size_ancestor_bag();
int size_ancestor_set();
int proof_length();
int subsume();
int map_rest();
int anc_subsume();
struct clause *forward_subsume();
struct clause_ptr *back_subsume();
struct clause_ptr *unit_conflict();
int pos_clause();
int neg_clause();
int num_literals();
int unit_clause();
void append_cl();
void prepend_cl();
void insert_before_cl();
void insert_after_cl();
void rem_from_list();
void insert_clause();
int weight_cl();
void hide_clause();
void del_hidden_clauses();
struct clause *cl_copy();
void remove_var_syms();
void cl_insert_tab();
void cl_delete_tab();
struct clause *cl_find();
void sort_lits();
void all_cont_cl();
void zap_cl_list();
void mark_literal();
void get_ancestors();
int proof_level();
int renumber_vars();
int renum_vars_term();
void clear_var_names();
void cl_clear_vars();
void distinct_vars_rec();
int distinct_vars();
struct clause *find_first_cl();
struct clause *find_last_cl();
struct clause *find_random_cl();
struct clause *find_lightest_cl();
struct clause *find_given_clause();
struct clause *extract_given_clause();
int unit_del();
int n_resolution_check();

/* options.c */

void init_options();
void print_options();
void p_options();
int change_flag();
int change_parm();
void check_options();
void dependent_options();

/* resolve.c */

void hyper_res();
void neg_hyper_res();
void ur_res();
int one_unary_answer();
struct term *build_term();
void combine_answers();
struct clause *build_bin_res();
void bin_res();
void all_factors();

/* index.c */

void index_lits_all();
void un_index_lits_all();
void index_lits_clash();
void un_index_lits_clash();

/* paramod.c */

void para_from();
void para_into();

/* formula.c */

void print_formula();
void p_formula();
int sprint_formula();
struct formula *str_formula();
struct formula *read_formula();
struct formula_ptr *read_formula_list();
void print_formula_list();
struct formula *copy_formula();
void zap_formula();
struct formula *negate_formula();
struct formula *nnf();
struct formula *skolemize();
struct formula *anti_skolemize();
void subst_free_formula();
void gen_sk_sym();
int skolem_symbol();
int contains_skolem_symbol();
int new_var_name();
int new_functor_name();
void unique_all();
struct formula *zap_quant();
void flatten_top();
struct formula *cnf();
struct formula *dnf();
void rename_syms_formula();
void subst_sn_term();
void subst_sn_formula();
int gen_subsume_prop();
struct formula *subsume_conj();
struct formula *subsume_disj();
int formula_ident();
void conflict_tautology();
void ts_and_fs();
struct list *clausify();
struct list *clausify_formula_list();
struct formula *negation_inward();
struct formula *expand_imp();
struct formula *iff_to_conj();
struct formula *iff_to_disj();
struct formula *nnf_cnf();
struct formula *nnf_dnf();
struct formula *nnf_skolemize();
struct formula *clausify_formed();
void rms_conflict_tautology();
struct formula *rms_subsume_conj();
struct formula *rms_subsume_disj();
int free_occurrence();
struct formula *rms_distribute_quants();
struct formula *rms_push_free();
struct formula *rms_quantifiers();
struct formula *rms();
struct formula *renumber_unique();
int gen_subsume_rec();
int gen_subsume();
int gen_conflict();
int gen_tautology();
struct formula *rms_cnf();
struct formula *rms_dnf();

/* process.c */

void post_proc_all();
void infer_and_process();
int proc_gen();
void pre_process();

/* misc.c */

void init();
void read_all_input();
void set_lex_vals();
void set_lrpo_status();
void set_special_unary();
void set_skolem();
void free_all_mem();
void output_stats();
void print_stats();
void print_stats_brief();
void p_stats();
void print_times();
void print_times_brief();
void p_times();
void append_lists();
struct term *copy_term();
int biggest_var();
void zap_list();
int occurs_in();
int sn_occur();
int is_atom();
int ident_nested_skolems();
int ground();
void cleanup();
int check_stop();
void report();
void reduce_weight_limit();
void control_memory();
void print_proof();
struct clause *check_for_proof();

/* lrpo.c */

int lrpo();
int lrpo_greater();
int order_equalities_lrpo();

/* linkur.c */

void linked_ur_res();
int process_linked_tags();

/* linkhyp.c */

void linked_hyper_res();
